#ifndef __robot_controller_h___
#define __robot_controller_h___

#ifdef __BORLANDC__
	#define __EXPORT _export
#else
  #ifdef _MSC_VER
  #define __EXPORT __declspec(dllexport)
  #endif
#endif

typedef struct {
  float x ;
  float y ;
  float heading ;
} CONTROLLER_INPUTS, *CONTROLLER_INPUTS_PTR ;

typedef struct {
	float motor_left ;
  float motor_right ;
} CONTROLLER_OUTPUTS, *CONTROLLER_OUTPUTS_PTR ;


#ifdef __cplusplus
extern "C" {
#endif

/*
	Retour d'une description du contrleur

  Optionnel, mais conseill : a permet de savoir  qui est le bijou lorsqu'on dpouille
  les logs
*/
char* __EXPORT cdecl GetDescription(void) ;

/*
	Initialisation du contrleur.

  Invoqu juste aprs le chargement de la DLL.

  Optionnel
*/
void __EXPORT cdecl Init(void) ;

/*
	Nettoyage avant dchargement.

  Invoqu juste avant le dchargement de la DLL.

  Optionnel
*/
void __EXPORT cdecl Cleanup(void) ;

/*
	Remise du contrleur en situation initiale.

  Invoqu lors de l'utilisation de la commande Reset de Robot Race

  Optionnel
*/
void __EXPORT cdecl Reset(void) ;

/*
	Calcul des consignes de contrle du robot.

  Invoqu  chaque pas de temps de la simulation.

  OBLIGATOIRE bien entendu.
*/
void __EXPORT cdecl Progress(
	float delta_time,								// delta entre cette invocation et la prcdente (en secondes)
  float new_time,									// temps coul
  CONTROLLER_INPUTS_PTR inputs, 	// pointeur sur les informations en entre
  CONTROLLER_OUTPUTS_PTR outputs 	// pointeur sur les consignes en sortie
) ;


#ifdef __cplusplus
}
#endif

#endif



