#include "test2.h"
              
// les indicateurs du robot
int flag_jack = 0;
int count = 0;

// initialisation des tats (extern)
int state = 0;
int movegauche_state = 0;
int parcourstrous_state = 0;


char* __EXPORT cdecl GetDescription(void)
{
 	return "@version 21/03/2006";
}
              
/**
 * Affiche un message sur le priphrique de sortie
 * remplacer par le code de Gilles, ou quivalent selon le priphrique 
 */
void log(char* msg) {
	printf(msg);
}

/**
 * Dmarrage du robot, premier tat
 */
void initRobot(void) {
	log("Init Robot\n");
   // tests des cartes filles ?
   // premier tat : attente du jack en entre
   // SIMU : passer tout de suite  jackout
   state = ST_JACKOUT;
   entryJackout();
}


/**
 * Analyse le robot, gre les timers, ... (code de Gilles)
 */
void analyseRobot(float new_time) {
      // analyse clavier (dans le simu)

}


/************************/
/******** ENTRY *********/
/************************/
void entryWaitjk() {
	//
   log("En attente du jack\n");
}

void entryJackin() {
 	//
   log("Jack entr\n");
}

void entryJackout() {
 	//
   log("Et c'est parti !\n");
   // initialiser le compteur
   //  remplacer par la routine du simulateur (nb de seconde)
	count = 0;
   // demander la tache "arret" dans 90000 ms
} 

void entryMovegauche() {
 	//
   log("Mouvement par la gauche\n");
   //
   movegauche_state = MG_CAP90;
}

void entryParcourstrous() {         
 	//
   log("Parcours trous gauche\n");
   parcourstrous_state = PT_TURN45M;
}

void entryChercheballe() {
 	//
   log("Recherche balle\n");
}

/************************/
/********* DO ***********/
/************************/
void doWaitjk() {
	// vrifier une panne ??
	// attendre le jack
   if (flag_jack == 1) {
   	state=ST_JACKIN;
    	exitWaitjk();
      entryJackin();
   }
}

void doJackin() {
 	// attendre la sortie du jack
   if (flag_jack == 0) {
   	state=ST_JACKOUT;
      exitJackin();
      entryJackout();
   }
}

void doJackout() {
 	// analyser le terrain au dmarrage
	log("Do jackout\n");   
   // choisir une stratgie

   // MODE SIMU : partir  gauche
   state=ST_MOVEGAUCHE;
   exitJackout();
   entryMovegauche();

   // autre possibilit, partir en recherche de balles
   /*
	state=ST_CHERCHEBALLE;
   exitJackout();
   entryChercheballe();
   */

}             


/**
 * Le parcours de trous est prenregistr.
 */
void doParcourstrous(CONTROLLER_INPUTS_PTR inputs, 	// pointeur sur les informations en entre
  CONTROLLER_OUTPUTS_PTR outputs) 						// pointeur sur les consignes en sortie)
{
	printf("%d ",parcourstrous_state);
	switch (parcourstrous_state) {
   	case PT_TURN45M:
         // le mouvement  faire
         if (inputs->heading < -45) {
	         outputs->motor_left = -MAX_SPEED;
   	      outputs->motor_right = MAX_SPEED;
         } else {
      	   outputs->motor_left = MAX_SPEED;
         	outputs->motor_right = -MAX_SPEED;
         }
         // la condition de sortie
			if (inputs->heading >= -46 && inputs->heading <= -44) {
         	// on est sur le bon cap
				outputs->motor_left = 0;
				outputs->motor_right = 0;
			   parcourstrous_state = PT_AXE860M;
         }
      	break;
    	case PT_AXE860M:
			if (inputs->x < -86.0) {
            outputs->motor_left = MAX_SPEED;
   	      outputs->motor_right = MAX_SPEED;
         }
         if (inputs->x >= -86.0) {
				outputs->motor_left = 0;
   	      outputs->motor_right = 0;
            parcourstrous_state = PT_TURN0;
         }
         // on est  la bonne position
			break;
   	case PT_TURN0:
         // le mouvement  faire
         if (inputs->heading < 0) {
	         outputs->motor_left = -MAX_SPEED;
   	      outputs->motor_right = MAX_SPEED;
         } else {
      	   outputs->motor_left = MAX_SPEED;
         	outputs->motor_right = -MAX_SPEED;
         }
         // la condition de sortie
			if (inputs->heading >= -1.0 && inputs->heading <= 1.0) {
         	// on est sur le bon cap
				outputs->motor_left = 0;
				outputs->motor_right = 0;
			   parcourstrous_state = PT_TROU1;
         }
      	break;
      case PT_TROU1:
	      if (inputs->y < 16.0) {
            outputs->motor_left = MAX_SPEED;
   	      outputs->motor_right = MAX_SPEED;
         }
         if (inputs->y >= 16.0) {
				outputs->motor_left = 0;
   	      outputs->motor_right = 0;
            //parcourstrous_state = PT_TURN0;
         }
         if (inputs->heading > 2.0 || inputs->heading < -2.0) {
            parcourstrous_state = PT_TURN0;
         }

      	break;
   }
}

/************************/
/******** EXIT **********/
/************************/
void exitWaitjk() {
	// nope
}

void exitJackin() {
 	// nope
}

void exitJackout() {
 	// nope
}

void __EXPORT cdecl Init(void) {
 	initRobot();
}

void __EXPORT cdecl Reset(void) {
 	initRobot();
}

void __EXPORT cdecl Progress(
	float delta_time,								// delta entre cette invocation et la prcdente (en secondes)
  float new_time,									// temps coul
  CONTROLLER_INPUTS_PTR inputs, 	// pointeur sur les informations en entre
  CONTROLLER_OUTPUTS_PTR outputs 	// pointeur sur les consignes en sortie
)
{
   analyseRobot(new_time);
	// analyse des dlais de taches


	//printf("(%f,%f)\n",inputs->x,inputs->y);

	switch (state) {
   	case ST_WAITJK:
			doWaitjk();
			break;
		case ST_JACKIN:
			doJackin();
			break;
		case ST_JACKOUT:
			doJackout();
			break;
		case ST_MOVEGAUCHE:
			doMovegauche(inputs,outputs);
			break;
		case ST_PARCOURSTROUS:
      	doParcourstrous(inputs,outputs);
         break;         
	}

	// analyse des dmarrages de taches

}

